<template>
  <div>
    <li>
      <a
        @click.prevent="$refs.balanceModal.Open();  getTransactions();"
        class="kioskbutton" data-control="PopupTrigger"><img src="/images/kiosk-button1-checkbalances.png"></a>
    </li>
    <balance-modal ref="balanceModal">
      <div slot="check-balance" id="overlay">
        <section
          v-show="!viewTransactions"
          id="checkbalancewindow"
          data-control="Popup"
          style="display: block;"
          class="modalwindow" >
          <div class="windowcontent">Your Balance is: <span class="popupdarkblue">${{ balance }}</span>
            <div class="popupbuttoncontainer viewtransactions">
              <div class="popupbtn buttonleft"></div>
              <div
                @click="getTransactions(); viewTransactions = true;"
                class="popupbtn buttonmiddle">View Transactions
              </div>
              <div class="popupbtn buttonright"></div>
              <div class="clear"></div>
            </div>
          </div>
          <a @click="$refs.balanceModal.Close(); viewTransactions = false" class="close closebutton maskfadeout" data-dismiss="modal"><img src="/images/closebutton.png"></a>
        </section>
        <section
          v-show="viewTransactions"
          class="modalwindow"
          id="transactionwindow"
          data-control="Popup">
          <div class="windowcontent">
            <h2>Transaction History</h2>
            <table
              border="0"
              cellspacing="0"
              cellpadding="5">
              <tr>
                <th scope="col">Date</th>
                <th scope="col">Description</th>
                <th scope="col">Deposit</th>
                <th scope="col">Withdrawal</th>
                <!-- <th scope="col">Account Balance</th> -->
              </tr>
              <!-- from API call -->
              <tr
                v-for="(transaction, index) in transactions"
                :key="index">
                <td>{{ moment.utc(transaction.time).local().format('MMM Do h:mm A') }}</td>
                <td>{{ transaction.name }}</td>
                <td class="numbercol">{{ transaction.deposit }}</td>
                <td class="numbercol">{{ transaction.withdrawal }}</td>
                <!-- <td
                  v-if="transaction.name === 'Initial Deposit'"
                  class="numbercol">{{transaction.deposit}}
                </td>
                <td
                  v-else
                  class="numbercol">index -1 += index blah
                </td> -->
              </tr>
            </table>
            <!-- <h3>Your total balance is: $<span
              class="popupdarkblue">{{ balance }}
              </span>
            </h3> -->
          </div>
          <a @click="$refs.balanceModal.Close(); viewTransactions = false" class="close closebutton maskfadeout" data-dismiss="modal"><img src="/images/closebutton.png"></a>
        </section>
      </div>
    </balance-modal>
  </div>
</template>

<script>
import BalanceModal from '../../../shared/views/ShopModal.vue';
export default {
  components: {
    BalanceModal,
  },
  data() {
    return {
      viewTransactions: false,
      transactions: [],
      balance: ''
    }
  },
  props: {
    accountId: Number
  },
  methods: {
    getTransactions() {
      app.api.Get(`transaction/getByAccountId/${this.accountId}`)
        .then( response => {
          console.log(response);

          this.transactions = response;
          this.calculateTotalBalance();
          // this.$emit('authenticated', this.account);
        })

    },
    calculateTotalBalance() {
      const amounts = [];
      // const self = this;
      this.transactions.map(function (transaction, index) {
        if (transaction.deposit) {
          amounts.push(transaction.amount);
          } else if (transaction.withdrawal) {
            amounts.push(-transaction.amount);
          }
      })
      console.log(amounts);

      this.balance = amounts.reduce((acc, cv) => acc + cv, 0).toFixed(2);
    }
  },
  computed: {
    popInitialDeposit: function() {

    }
  }
}
</script>